/*
The software and accompanying written material (including instructions for use) are provided "as is" without warranty of any kind. 
Further, Yaqingda does not warrant, guarantee or make any representations regarding the use or the results of use, 
of the Software or written materials in terms of correctness, reliability, 
accuracy or fitness for purpose. The entire risk as to the results and performance of the software is assumed by you. 
Should the software be defective, you and not Yaqingda. or its dealers, agents,
distributors or employees, assume the entire cost of all necessary repair, servicing and correction.

The above is the only warranty of any kind, either express or implied,
including but not limited to the warranties of merchantability and fitness for purpose, 
that Yaqingda makes regarding this product. No oral or written information or advise given by Yaqingda. 
or its dealers, agents, distributors or employees shall create a warranty or in any way increase the scope of this warranty.

Neither Yaqingda nor anyone else who has been involved in the creation, 
production or delivery of this product shall be liable for any direct, 
indirect, consequential or incidental damages ( including damages for loss of
business profits, business interruption, loss of business information, and the like.) 
arising out of the use or inability to use this product even if Yaqingda has been advised of the possibility of such damages.

#Copyright Notice
Yaqingda copyrights this specification. No part of this specification may be reproduced in any form or means, without the prior written consent of Yaqingda.

#Disclaimer
This specification is preliminary and is subject to change at any time without notice. Yaqingda assumes no responsibility for any errors contained herein.

©2019 Guangzhou Yaqingda Intelligent Systems Co.Ltd. All rights reserved.
*/

/**
 * 单、双屏专用版本
 * 
 * 
 */
const xapi = require('xapi');
 const serverUrl = 'https://touch10.1table.cn:8188'
const verNum = '1.0.0' //客户端版本号

xapi.event.on('UserInterface Extensions Widget Action', (event) => {

if (event.WidgetId === 'button-upgrade' && event.Type === 'pressed') {
    //平板控制软件升级
    Yaqingda_checkUprade();
  } else if (event.WidgetId === 'button-uninstall' && event.Type === 'pressed') {
    //平板控制软件卸载
    Yaqingda_uninstall();
  } else if (event.WidgetId === 'button_system_upgrade' && event.Type === 'pressed') {
    //终端系统软件升级
    Yaqingda_checkSystemUprade();
  }
})

// xapi.event.on('UserInterface Message TextInput Response', (event) => {

//   if (event.FeedbackId === 'phonenumber') {
//     phonenumber = event.Text
//     if (typeof phonenumber === "undefined" || phonenumber.length !== 11) {
//       msg.Yaqingda_showPromptResponseMsg("请输入正确的手机号", 'phonenumber', 'OK')
//       return;
//     }
//     Yaqingda_executecommand_sendsms(phonenumber)
//   } else if (event.FeedbackId === 'smscode') {
//     var smsCode = event.Text
//     if (smsCode.length !== 6) {
//       msg.Yaqingda_showPromptResponseMsg("请输入正确的验证码", 'smscode', 'OK')
//       return
//     }
//     Yaqingda_executecommand_active(phonenumber, event.Text)
//   }

// })

xapi.event.on('UserInterface Message Prompt Response', (event) => {
  // console.log("event:", JSON.stringify(event));
  // if (event.FeedbackId === 'phonenumber') {
  //   xapi.command('UserInterface Message TextInput Display', {
  //     FeedbackId: 'phonenumber',
  //     Title: '请输入电话号码',
  //     Text: '请输入',
  //   });
  // } else if (event.FeedbackId === 'smscode') {
  //   xapi.command('UserInterface Message TextInput Display', {
  //     FeedbackId: 'smscode',
  //     Title: '请输入短信验证码',
  //     Text: '请输入',
  //   });
  // } else 
  if (event.FeedbackId === 'upgrade' && event.OptionId === '1') {
    console.log('客户端升级开始');
    var counter = 0
    var count = 600
    var progress = ".....".padEnd(count, '.')
    var timer = setInterval(function (event) {
        // cb(progress.substring(0, counter + 1))
        msg.Yaqingda_showPromptMsgWithoutDuration("请稍候，升级中("+counter+"s)");
        
        counter++;
        if (counter >= count  ) {
            clearInterval(timer)
        }
    }, 1000)

    // msg.Yaqingda_showPromptMsgWithoutDuration('客户端升级中...');
    xapi.command('Provisioning Service Fetch', {
      url: meetControlUrl
    }).then(console.log("Provisioning Service Fetch successfully"))

  } else if (event.FeedbackId === 'upgrade_system' && event.OptionId === '1') {
    console.log('系统软件升级开始', systemUrl);
    msg.Yaqingda_showPromptMsgWithoutDuration('系统软件升级中...');
    xapi.command('SystemUnit SoftwareUpgrade', {
      url: systemUrl,
      Forced: false
    }).then((result) => {
      console.log("SoftwareUpgrade", result);
    }).catch(handleError);

  }else if (event.FeedbackId === 'unitall' && event.OptionId === '1') {
    console.log('卸载宏程序开始');
    
    xapi.command(' Macros Macro RemoveAll').then((result) => {
      xapi.command(' UserInterface Extensions Clear').then((result)  => {
        msg.Yaqingda_showPromptMsg('平板控制软件已卸载...');
        console.log('卸载宏程序完成');
      }).catch(handleError);
    }).catch(handleError);

  }
})

function handleError (error) {
  console.log('Error', error);
  msg.Yaqingda_showPromptMsg('系统异常:' + error.message);
}


// function Yaqingda_checkActived (user_name) {

//   xapi.command('HttpClient Get', {
//     Header: ["Content-Type: application/json"],
//     Url: serverUrl + "/isactivedAccount?user_name=" + user_name + domain
//   })
//     .then((result) => {
//       console.log(`active status:${result.Body}`)
//       var body = JSON.parse(result.Body)
//       isactive = body.status
//     })
//     .catch((err) => {
//       console.log("panel active failed: " + err.message)
//       msg.Yaqingda_showalert('请检查网络连接是否正常！', 60);
//       // xapi.command('Macros Runtime Restart');
//     });
//   // })
// }

/**
 * 
 */
// function checkActived () {
//   xapi.config.get('Provisioning LoginName').then((user_name) => {
//     var payload = JSON.stringify({
//       'user_name': user_name + domain
//     });

//     console.log(payload);

//     xapi.command('HttpClient Post', {
//       Header: ["Content-Type: application/json"],
//       Url: serverUrl + '/isActived',
//       ResultBody: "PlainText"
//     },
//       payload)
//       .then((result) => {
//         var strR = JSON.stringify(result)
//         console.log("strR:" + strR)

//         var body = JSON.parse(result.Body)
//         isactive = body.status

//       })
//       .catch((err) => {
//         console.log("failed: " + err.message)
//         msg.Yaqingda_showalert("系统错误")
//       });
//   })
// }

// //发送验证码
// function Yaqingda_executecommand_sendsms (phonenumber) {

//   // if (typeof phonenumber === "undefined" || phonenumber.length !== 11) {
//   //   console.log("长度校验");
//   //   Yaqingda_showPromptMsg("请输入正确的手机号", 'phonenumber')
//   //   return;
//   // }
//   // Yaqingda_showalert_short('验证码已成功发送')

//   // xapi.status.get('SystemUnit Hardware Module SerialNumber').then((s_number) => {
//   xapi.config.get('Provisioning LoginName').then((user_name) => {

//     var payload = JSON.stringify({
//       'phonenumber': phonenumber,
//       'command': 'requestdySmsCode',
//       'user_name': user_name + domain,
//       's_number': s_number
//     });

//     console.log(payload);

//     xapi.command('HttpClient Post', {
//       Header: ["Content-Type: application/json"],
//       Url: serverUrl,
//       ResultBody: "PlainText"
//     },
//       payload)
//       .then((result) => {
//         var strR = JSON.stringify(result)
//         console.log("strR:" + strR)

//         var body = JSON.stringify(result.Body)
//         console.log("body:" + body)

//         var jsonBody = JSON.parse(result.Body)

//         // Yaqingda_showPromptMsg(jsonBody.msg)
//         if (jsonBody.status) {
//           msg.Yaqingda_showPromptResponseMsg(jsonBody.msg, 'smscode', 'OK')
//         } else {
//           msg.Yaqingda_showPromptResponseMsg(jsonBody.msg, 'phonenumber', 'OK')
//         }

//       })
//       .catch((err) => {
//         console.log("failed: " + err.message)
//         msg.Yaqingda_showalert("系统错误,请联系客服");
//       });
//   })
//   // })
// }

// //激活
// function Yaqingda_executecommand_active (phonenumber, smscode) {

//   xapi.status.get('SystemUnit Hardware Module SerialNumber').then((s_number) => {
//     xapi.config.get('Provisioning LoginName').then((user_name) => {
//       var payload = JSON.stringify({
//         'phonenumber': phonenumber,
//         'command': 'active',
//         'sms_key': smscode,
//         'user_name': user_name + domain,
//         's_number': s_number,
//         // 'key': key

//       });

//       console.log(payload);

//       xapi.command('HttpClient Post', {
//         Header: ["Content-Type: application/json"],
//         Url: serverUrl,
//         ResultBody: "PlainText"
//       },
//         payload)
//         .then((result) => {
//           var strR = JSON.stringify(result)
//           console.log("strR:" + strR)

//           var jsonBody = JSON.parse(result.Body)
//           if (jsonBody.status === 0) {
//             isactive = 1
//             msg.Yaqingda_showPromptMsg("激活成功!");

//             xapi.command('Macros Runtime Restart');
//           } else {
//             msg.Yaqingda_showPromptResponseMsg(jsonBody.msg, 'smscode', 'OK')
//             return;
//           }
//         })
//         .catch((err) => {
//           console.log("failed: " + err.message);
//           msg.Yaqingda_showPromptMsg("激活失败，请联系客服!");
//         });

//     })
//   })
// }

/**
 * 检查平板控制软件是否需要更新
 */
function Yaqingda_checkUprade () {
  //如果系统版本低于 9.8，提示“请先升级终端系统软件”
  var p1 = new Promise((resolve, reject) => {
    xapi.status.get('Provisioning Software Current VersionId').then((versionId) => {
      versionId = versionId.split(' ')[0]
      resolve(versionId);
    }).catch(handleError);
  });
  //版本1.262 update start
  var p2 = new Promise((resolve, reject) => {
    xapi.status.get('SystemUnit ProductPlatform').then((platform) => {
      resolve(platform);
    }).catch(handleError);
  });

  var p = Promise.all([p1, p2]).then(function (posts) {
    console.log("posts", posts);
    var result = posts[0]; //版本号
    var platform = posts[1]; //平台类型

    if (compareVersion('9.8.0', result.replace('ce', '').replace('tc', ''))) {
      msg.Yaqingda_showalert("请先升级终端系统软件！", 0)
      return;
    }
    let url = serverUrl + '/getVersion?type=1&producttype=4';
    xapi.command('HttpClient Get', {
      Header: ["Content-Type: application/json"],
      Url: url
    })
      .then((result) => {
        console.log("Yaqingda_checkUprade ", result.Body)
        var body = JSON.parse(result.Body)
        var code = body.code;
        if (code === 0) {
          verNumDb = body.data[0].touch_ver
          console.log("verNumDb ", verNumDb)
          if(compareVersion(verNumDb,verNum)){
            meetControlUrl = body.data[0].download_url;
            msg.showPromptTwoOptions("检测到新版本，请升级！", 'upgrade', 'OK', '忽略');
          } else {
            msg.Yaqingda_showalert("当前为最新版本！")
          }
        } else {
          msg.Yaqingda_showalert("系统错误！")
        }
      })
      .catch((err) => {
        console.log("failed: " + err.message)
        msg.Yaqingda_showalert("请检查网络连接！")
      });
  })

  // var p2 = p1.then(function (result) {
  //   if (compareVersion('9.8.0', result.replace('ce', '').replace('tc', ''))) {
  //     msg.Yaqingda_showalert("请先升级终端系统软件！", 0)
  //     return;
  //   }

  //   xapi.command('HttpClient Get', {
  //     Header: ["Content-Type: application/json"],
  //     Url: serverUrl + "/getVersion?type=1&producttype=1"
  //   })
  //     .then((result) => {
  //       console.log("Yaqingda_checkUprade ", result.Body)
  //       var body = JSON.parse(result.Body)
  //       var code = body.code;
  //       if (code === 0) {
  //         verNumDb = body.data[0].version_no
  //         console.log("verNumDb ", verNumDb)
  //         if (verNumDb > verNum) {
  //           meetControlUrl = body.data[0].download_url;
  //           // Yaqingda_showPromptMsg("检测到新版本，请升级！")
  //           msg.showPromptTwoOptions("检测到新版本，请升级！", 'upgrade', 'OK', '忽略');
  //         } else {
  //           msg.Yaqingda_showalert("当前为最新版本！")
  //         }
  //       } else {
  //         msg.Yaqingda_showalert("系统错误！")
  //       }
  //     })
  //     .catch((err) => {
  //       console.log("failed: " + err.message)
  //       msg.Yaqingda_showalert("请检查网络连接！")
  //     });
  // })
  //版本1.262 update end
}


/**
 * 卸载平板控制软件
 */
function Yaqingda_uninstall () {
  msg.showPromptTwoOptions(`确认卸载？`, 'unitall', '狠心卸载', '取消');
}

/**
 * 检查终端系统软件是否需要更新
 */
function Yaqingda_checkSystemUprade () {
  var p1 = new Promise((resolve, reject) => {
    xapi.status.get('Provisioning Software Current VersionId').then((versionId) => {
      versionId = versionId.split(' ')[0]
      resolve(versionId);
    }).catch(handleError);
  });

  var p2 = new Promise((resolve, reject) => {
    xapi.status.get('SystemUnit ProductPlatform').then((platform) => {
      resolve(platform);
    }).catch(handleError);
  });

  var p = Promise.all([p1, p2]).then(function (posts) {
    console.log("posts", posts);
    var currentVerNum = posts[0]; //版本号
    var producttype = '';
    var platform = posts[1];
    let download_url = '';
    if (platform === "DX80" || platform === "DX70") {
      producttype = 1;
      download_url = 'https://www.1table.cn/static/v2/downloadCenter/client/dxseries/s52040ce9_8_1-0f71ac008c3.pkg';

    } else if (platform === "Codec" || platform === "Codec Plus" || platform === "Room Kit" || platform === "Room55"
      || platform === "Room55D" || platform === "Room70" || platform === "Room70D" || platform === "Board55"
      || platform === "Board55S" || platform === "Board70" || platform === "Board70S" || platform === "Board85S"|| platform === "Room Kit Mini"
    ) {
      producttype = 2;
      download_url = 'https://www.1table.cn/static/v2/downloadCenter/client/roomkit/cmterm-s53200ce9_8_1-0f71ac008c3.k3.cop.sgn';

    } else if (platform === "SX10") {
      producttype = 3;
      download_url = 'https://www.1table.cn/static/v2/downloadCenter/client/sxseries/SX10/s52030ce9_8_1-0f71ac008c3.pkg';

    } else if (platform === "CodecPro" || platform === "Codec Pro" || platform === "Room70 G2" || platform === "Room70G2") {
      producttype = 4;
      download_url = 'https://www.1table.cn/static/v2/downloadCenter/client/roomkitpro/cmterm-s53300ce9_8_1-0f71ac008c3.k3.cop.sgn'

    } else if (platform === "SX20" || platform === "MX300 G2" || platform === "MX300G2") {
      producttype = 5;
      download_url = 'https://www.1table.cn/static/v2/downloadCenter/client/sxseries/SX20/s52010ce9_8_1-0f71ac008c3.pkg'

    } else if (platform === "SX80" || platform === "MX700" || platform === "MX800") {
      producttype = 6;
      download_url = 'https://www.1table.cn/static/v2/downloadCenter/client/sxseries/SX80 MX700 800/s52020ce9_8_1-0f71ac008c3.pkg'
    }
    //9.8以下不支持Get,默认升级到9.8
    if (compareVersion('9.8.0', currentVerNum.replace('ce', '').replace('tc', ''))) {

      msg.Yaqingda_showPromptMsgWithoutDuration('系统软件升级中...');
      xapi.command('SystemUnit SoftwareUpgrade', {
        url: download_url,
        Forced: false
      }).then((result) => {
        console.log("SoftwareUpgrade", result);
      }).catch(handleError);
      return;
    }

    xapi.command('HttpClient Get', {
      Header: ["Content-Type: application/json"],
      Url: serverUrl + "/getVersion?type=2&producttype=" + producttype
    }).then((result) => {
      console.log("Yaqingda_checkSystemUprade ", result.Body)
      var body = JSON.parse(result.Body)

      if (producttype === 5) {
        if (compareVersion( 'tc7.1.1'.replace('tc', ''),currentVerNum.replace('ce', '').replace('tc', ''))) {
          verNumDb = body.data[1].version_no
          systemUrl = body.data[1].download_url;
        } else {
          verNumDb = body.data[0].version_no
          systemUrl = body.data[0].download_url;
        }
      } else {
        if (compareVersion('ce9.4.1'.replace('ce', ''),currentVerNum.replace('ce', '').replace('tc', ''))) {
          verNumDb = body.data[1].version_no
          systemUrl = body.data[1].download_url;
          // } else if (currentVerNum < 'ce9.8.1') {
        } else {
          verNumDb = body.data[0].version_no
          systemUrl = body.data[0].download_url;
        }
      }

      console.log(`verNumDb ${verNumDb} systemUrl ${systemUrl}`);
      if (compareVersion(verNumDb.replace('ce', '').replace('tc', ''), currentVerNum.replace('ce', '').replace('tc', ''))) {
        // if (verNumDb > currentVerNum) {

        msg.showPromptTwoOptions(`检测到新版本${verNumDb}，请升级！`, 'upgrade_system', 'OK', '忽略');
      } else {
        msg.Yaqingda_showalert("当前为最新版本！")
      }

    })
      .catch((err) => {
        console.log("Yaqingda_checkSystemUprade failed: " + err);
        msg.Yaqingda_showPromptMsg("升级失败，请联系客服!");
      });
  }).catch(function (reason) {
    console.log("Yaqingda_checkSystemUprade failed: " + err);
    msg.Yaqingda_showPromptMsg("升级失败，请联系客服!");
  });

}

/**
 * 比较版本大小，aVersion > aVersion 返回true ，以外返回false
 * @param {*} aVersion 
 * @param {*} bVersion 
 */
function compareVersion (aVersion, bVersion) {
  var a = (aVersion != null ? aVersion : "");
  var b = (bVersion != null ? bVersion : "");
  var aStringArray = a.split(".");
  var bStringArray = b.split(".");
  var loopCount = Math.min(aStringArray.length, bStringArray.length);
  for (var i = 0; i < loopCount; i++) {
    if (parseInt(aStringArray[i]) > parseInt(bStringArray[i])) {
      return true;
    }
    else if (parseInt(aStringArray[i]) < parseInt(bStringArray[i])) {
      return false;
    }
  }
  return aStringArray.length > bStringArray.length;
}

var msg = {
  Yaqingda_showPromptMsg: function (text) {
    xapi.command('UserInterface Message Prompt Display', {
      Title: '提示',
      Text: text,
      Duration: 5
    });
  },

  Yaqingda_showPromptResponseMsg: function (text, feedbackId, option) {
    xapi.command('UserInterface Message Prompt Display', {
      Title: '提示',
      Text: text,
      FeedbackId: feedbackId,
      'Option.1': option
    });
  },
  Yaqingda_showalert: function (text, duration = 5) {

    xapi.command('UserInterface Message Alert Display', {
      Title: '提示',
      Text: text,
      Duration: duration,
    });
  },
  showPromptTwoOptions: function (text, feedbackId, option1, option2) {
    xapi.command('UserInterface Message Prompt Display', {
      Title: '提示',
      Text: text,
      FeedbackId: feedbackId,
      'Option.1': option1,
      'Option.2': option2
    });
  },
  Yaqingda_showPromptMsgWithoutDuration: function (text) {
    xapi.command('UserInterface Message Prompt Display', {
      Title: '提示',
      Text: text
    });
  }
}

// let isactive = false
let verNumDb = '1'
let meetControlUrl = '';
let systemUrl = '';
// var phonenumber = ''
// let s_number;
let loginName = '';//注册账号

// xapi.command('UserInterface Extensions Widget SetValue ',
//   { WidgetId: 'widget_appversion', value: (appType + verNum) }).catch(handleError);

xapi.status.get('SystemUnit Hardware Module SerialNumber').then((s_number) => {
  s_number = s_number;
  // console.log(`s_number: ${s_number}`)
}).catch(handleError);

//版本1.262 update start
//如果系统版本低于 9.8，不能使用http get，提示“请先升级终端系统软件”
var p1 = new Promise((resolve, reject) => {
  xapi.status.get('Provisioning Software Current VersionId').then((versionId) => {
    versionId = versionId.split(' ')[0]
    resolve(versionId);
  }).catch(handleError);
});


var p2 = new Promise((resolve, reject) => {
  xapi.status.get('SystemUnit ProductPlatform').then((platform) => {
    resolve(platform);
  }).catch(handleError);
});

var p = Promise.all([p1, p2]).then(function (posts) {
  console.log("active.js started posts:", posts);
  var result = posts[0]; //版本号
  var platform = posts[1]; //平台类型
  //if (platform == "CodecPro" || platform == "Codec Pro") {
  //  msg.Yaqingda_showalert('该版本为单、双屏专用版本，请安装三屏版本', 60);
  //  return;
  //}

  if (!compareVersion('9.10.0', result.replace('ce', '').replace('tc', ''))) {
    xapi.config.set('UserInterface Features Call JoinWebex', 'hidden').
    catch((error) => {
      console.error(error);
    });
  }

  if (compareVersion('9.8.0', result.replace('ce', '').replace('tc', ''))) {
    msg.Yaqingda_showalert('请先升级终端系统软件！', 0);
    return;
  } else {
    setTimeout(function () {
      //检查设备是否已注册
      xapi.config.get('Provisioning LoginName').then((user_name) => {
        if (user_name === '' || user_name === null) {
          console.log("Provisioning LoginName get failed");
          // msg.Yaqingda_showalert('请确认该设备是否已注册,如已注册请忽略！', 60);
          return;
        } else {
          loginName = user_name;
        }

        // Yaqingda_checkActived(loginName);
        // Yaqingda_checkUprade();
        // Yaqingda_checkSystemUprade();
        // checkIsRegistedTerminal(loginName);
      });

    }, 5000);
  }

})