/*
The software and accompanying written material (including instructions for use) are provided "as is" without warranty of any kind. 
Further, Yaqingda does not warrant, guarantee or make any representations regarding the use or the results of use, 
of the Software or written materials in terms of correctness, reliability, 
accuracy or fitness for purpose. The entire risk as to the results and performance of the software is assumed by you. 
Should the software be defective, you and not Yaqingda. or its dealers, agents,
distributors or employees, assume the entire cost of all necessary repair, servicing and correction.

The above is the only warranty of any kind, either express or implied,
including but not limited to the warranties of merchantability and fitness for purpose, 
that Yaqingda makes regarding this product. No oral or written information or advise given by Yaqingda. 
or its dealers, agents, distributors or employees shall create a warranty or in any way increase the scope of this warranty.

Neither Yaqingda nor anyone else who has been involved in the creation, 
production or delivery of this product shall be liable for any direct, 
indirect, consequential or incidental damages ( including damages for loss of
business profits, business interruption, loss of business information, and the like.) 
arising out of the use or inability to use this product even if Yaqingda has been advised of the possibility of such damages.

#Copyright Notice
Yaqingda copyrights this specification. No part of this specification may be reproduced in any form or means, without the prior written consent of Yaqingda.

#Disclaimer
This specification is preliminary and is subject to change at any time without notice. Yaqingda assumes no responsibility for any errors contained herein.

©2019 Guangzhou Yaqingda Intelligent Systems Co.Ltd. All rights reserved.
*/

/**
 * 设备检测
 * 
 */
const xapi = require('xapi');
const serverUrl = 'https://touch10.1table.cn:8188'

let netStatus = 0;
let regStatus = 0;
let callStatus = 0;
let audioStatus = 0;
let provisionStatus = 0;
let outputStatus = 0;
let PresentationStatus = 0;
let resolution = '';//分辨率
let ChannelRate = '';//带宽

function showProgress(count, delay, cb, final, initial) {
  // console.log("showProgress")
  var counter = 0
  if (!initial) initial = ""
  var progress = ".....".padEnd(count, '.')
  var timer = setInterval(function (event) {
      cb(initial + progress.substring(0, counter + 1))
      counter++;
      if (counter >= count  ) {
          clearInterval(timer)
          cb(final)
          // xapi.command('UserInterface Extensions Panel Open', { PanelId: "panel_active" });
      }
  }, delay)
}


function showInstructions(message) {
  console.debug('updating instructions')

  xapi.command('UserInterface Extensions Widget SetValue', {
      WidgetId: 'instructions',
      Value: message
  })
}

//①、②、③、④、⑤、⑥、⑦、⑧、⑨、⑩
function Yaqingda_checkProvision () {

  // xapi.status.get('Provisioning Status').then((status) => {
  //   console.log(`Provisioning Status.${status}`);
  //   if(status  === 'Provisioned'){
  //     provisionStatus = 1;
  //     showProgress(6, 500, showInstructions, '设备已注册...', '①注册检测中');
  //   }else{
  //     provisionStatus = 2;
  //     showInstructions('设备未注册...')
  //   }
  //  })

  xapi.status.get('SIP Registration ').then((result) => {
    var res = JSON.stringify(result);
    console.log(`SIP Registration result.${res}`);

    var count = 0;
    for (var i = 0; i < result.length; i++) {
      var temp = result[i]
      if (temp.Status == 'Registered') {
        count++
      }
    }
    console.log('当前有' + count + '设备连接');
    if(count > 0){
      regStatus = 1;
      showProgress(6, 500, showInstructions, '设备已注册...', '②注册检测中');
    }else{
      regStatus = 2;
      showProgress(6, 500, showInstructions, '设备未注册...', '②注册检测中');
      console.error("设备未注册...");
    }
    // if(status  === 'Registered'){
    //   regStatus = 1;
    //   showProgress(6, 500, showInstructions, '设备已注册...', '①注册检测中');
    // }else{
    //   regStatus = 2;
    //   showProgress(6, 500, showInstructions, '设备未注册...', '①注册检测中');
    //   console.error("设备未注册...");
    // }
   })

  //  xapi.config.get('Provisioning LoginName').then((user_name) => {
  //   console.log(`Provisioning LoginName :${user_name}`);
  //   if (user_name === '' || user_name === null) {
  //     console.log("Provisioning LoginName get failed");
  //     // msg.Yaqingda_showalert('请确认该设备是否已注册！', 60);
  //     regStatus = 2;
  //     // showInstructions('设备未注册...')
  //     showProgress(6, 500, showInstructions, '设备未注册...', '①注册检测中');
  //     // return;
  //   }else{
  //     regStatus = 1;
  //   }
  //   })
  }

function Yaqingda_checkNet () {
  xapi.command('HttpClient Get', {
    Header: ["Content-Type: application/json"],
    Url: serverUrl + "/getCmsVersion"
  }).then((result) => {
    console.log(`cms version:${result.Body}`)
    var body = JSON.parse(result.Body)
    var code = body.code;
    if(code == 0){
      netStatus = 1;
      showProgress(6, 500, showInstructions, '网络连接正常...', '①网络检测中');
    }else{
      showProgress(6, 500, showInstructions, '网络连接正常...', '①网络检测中');
    }
  }).catch((err) => {
    console.log("failed: " + err.message)
    netStatus = 2;
    // showInstructions('网络未连接...')
    showProgress(6, 500, showInstructions, '网络未连接...', '①网络检测中');
    // msg.Yaqingda_showalert('请检查网络连接是否正常！', 60);
  });

}

function Yaqingda_checkAudio () {
  // xapi.status.get(' Audio SelectedDevice').then((device) => {
  //   console.log(`Audio SelectedDevice.${device}`);
  //   if(device === 'HeadsetUSB' ){

  //     xapi.status.get(' Audio Devices HeadsetUSB ConnectionStatus').then((status) => {
  //       console.log(`HeadsetUSB ConnectionStatus.${status}`);
  //       if(status === 'Connected'){
  //         audioStatus = 1;
  //         showProgress(6, 500, showInstructions, '耳机连接正常...', '耳机检测中');
  //       }else{
  //         audioStatus = 2;
  //         showProgress(6, 500, showInstructions, '未检测到耳机连接...', '耳机检测中');
  //       }
  //      })
  //   }else if(device === 'Internal'){
  //     console.error('未检测到耳机连接...');
  //     audioStatus = 2;
  //     showProgress(6, 500, showInstructions, '未检测到耳机连接...', '耳机检测中');
  //     // showInstructions('未检测到耳机连接...')
  //   }
  //  })

  xapi.status.get(' Audio Devices HeadsetUSB ConnectionStatus').then((status) => {
    console.log(`HeadsetUSB ConnectionStatus.${status}`);
    if(status === 'Connected'){
      audioStatus = 1;
      showProgress(6, 500, showInstructions, '耳机连接正常...', '③耳机检测中');
    }else{
      audioStatus = 2;
      showProgress(6, 500, showInstructions, '未检测到耳机连接...', '③耳机检测中');
    }
   })
}

function Yaqingda_checkOutput(){
  xapi.status.get('Video Output Connector').then((result) => {

    var count = 0;
    for (var i = 0; i < result.length; i++) {
      var temp = result[i]
      if (temp.Connected == 'True') {
        count++
      }
    }
    console.log('当前有' + count + '设备连接');
    if(count > 0){
      outputStatus = 1;
      showProgress(6, 500, showInstructions, '显示器连接正常...', '③显示器检测中');
    }else{
      outputStatus = 2;
      showInstructions('未检测显示器...')
    }
  });

}

function Yaqingda_checkPresentation(){
  //xapi.command('Presentation Start')
  //.then((res) => { 
    xapi.status.get(' Conference Presentation LocalInstance ').then((result) => {

      var count = 0;
      for (var i = 0; i < result.length; i++) {
        var temp = result[i]
        if (temp.SendingMode == 'LocalOnly') {
          count++
        }
      }
      console.log(` Conference Presentation LocalInstance ${count}`);
      if(count > 0){
        console.log('当前电脑已共享');
        PresentationStatus = 1;
        showProgress(6, 500, showInstructions, '电脑共享正常...', '④电脑共享检测中');
      }else{
        PresentationStatus = 2;
        showProgress(6, 500, showInstructions, '未检测到电脑共享...', '④电脑共享检测中');
        // showInstructions('未检测到电脑共享...')
      }
    }).catch((err) => {
      // Frequent error here is to have several on-going calls
      // reason: "Maximum limit of active calls reached"
      console.error(`未检测到电脑共享信号: ${err.message}`)
      PresentationStatus = 2;
      showProgress(6, 500, showInstructions, '未检测到电脑共享...', '④电脑共享检测中');
    });
  //})
}

function Yaqingda_checkDial () {
   // Start a call
   showProgress(6, 500, showInstructions, '请稍候...', '⑤呼叫检测中');
   setTimeout(() => {
        xapi.command('Dial', { Number: '6994591069@qqmra.com' }) .then((call) => {
          console.log(`Started call with status: ${call.status}, id: ${call.CallId}`);
          if(call.status === 'OK'){
            callStatus = 1;
            showProgress(6, 500, showInstructions, '设备呼叫正常...', '⑤呼叫检测中');
          }else{
            callStatus = 2;
          }
            setTimeout(() => {
            xapi.status.get(" MediaChannels Call ").then((result) => {
              var res = JSON.stringify(result);
              console.log(`MediaChannels Call ${res}`)
            
              for (var i = 0; i < result.length; i++) {
                var temp = result[i];
                for (var c = 0; c < temp.Channel.length; c++) {
                  var channel = temp.Channel[c]
                  
                  if(channel.Type == 'Video' && channel.Direction == 'Outgoing' && channel.Video.ChannelRole == 'Main'){
                    var strCh = JSON.stringify(channel);
                    console.log(`strCh: ${strCh}`)
                    console.log(`channel: ${channel.Video.ResolutionX} * ${channel.Video.ResolutionY}`)
                    console.log(`Netstat: ${channel.Netstat.ChannelRate}`)
                    resolution = channel.Video.ResolutionX +'*'+ channel.Video.ResolutionY;
                    ChannelRate=channel.Netstat.ChannelRate/1000 +'kbps'
                  }
                }
              }
            })
            }, 1 * 5000);

            // Stop call after delay
            const delay = 8;
            setTimeout(() => {
                console.log('Disconnecting call, and exiting.');
    
                xapi.command('Call Disconnect', { CallId: call.CallId })
                    .then(console.log('exited'));
                // xapi.command('UserInterface Extensions Panel Open', { PanelId: "panel_selfcheck" });

                // xapi.command('Presentation Start').then((res) => {});
            }, delay * 1000);
            console.log(`Call with be disconnected in ${delay} seconds...`);
    
        })
        .catch((err) => {
          console.error(`Error in call: ${err.message}`)
          callStatus = 2;
          showInstructions('呼叫失败...')
          showProgress(6, 500, showInstructions, '呼叫失败...', '⑤呼叫检测中');
        });
   }, 3000);
   
}
//自我检测
 function Yaqingda_selfcheck() {
  Yaqingda_checkNet()

  setTimeout(() => {
    Yaqingda_checkProvision()
  }, 5000);
  
  // setTimeout(() => {
  //   Yaqingda_checkAudio()
  // }, 10000);
  
    
  setTimeout(() => {
    Yaqingda_checkOutput()
  }, 10000);

  setTimeout(() => {
    Yaqingda_checkPresentation()
  }, 15000);

  setTimeout(() => {
    Yaqingda_checkDial()
  }, 20000);
  
  setTimeout(() => {

    let msg = '';
    if(netStatus > 1 ){
      msg += '网络连接失败;';
    }
    if(regStatus > 1 ){
      msg += '设备未注册;';
    }
    // if(audioStatus > 1 ){
    //   msg += '耳机未连接;';
    // }
    if(callStatus > 1 ){
      msg += '呼叫失败;';
    }
    if(outputStatus > 1 ){
      msg += '显示器未连接;';
    }
    if(PresentationStatus > 1 ){
      msg += '电脑未共享;';
    }
    if(msg == ''){
      msg = '设备正常'
    }
    if(resolution != ''){
      msg += ' 分辨率:'+resolution;
    }
    if(ChannelRate != ''){
      msg += ' 呼叫带宽:'+ChannelRate;
    }
      // xapi.command('UserInterface Message Alert Display', {
      //   Title: '检测结果',
      //     Text:msg,
      //     Duration: 15
      // })

      xapi.command('UserInterface Message Prompt Display', {
        Title: '检测结果',
        Text: msg,
        Duration: 15
      });

    showInstructions('点击开始按钮开始检测，检测过程中不要重复点击按钮')
  }, 35000);
  
}

// showProgress(50, 500, showInstructions, '设备正常...', '设备检测中');
// setTimeout(function(){ 

// console.log("waiting 3s");
// Yaqingda_selfcheck();

// }, 3000);



function onGui(event) {
  if (event.Type == 'clicked') {
      if (event.WidgetId == 'restart') {
        // showProgress(8, 500, showInstructions, '检测开始', '检测开始');
        Yaqingda_selfcheck()
          return
      }

      // No more event listener
      return
  }
}
xapi.event.on('UserInterface Extensions Widget Action', onGui);

